﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI

	Private btReceive As Button
	Private btSend As Button
	Private lbData As Label
	Private lbFromId As Label
	Private lbId As Label
	Private lbSystem As Label
	Private lbToId As Label
	Private txData As EditText
	Private txFromId As EditText
	Private txId As EditText
	Private txSystem As EditText
	Private txToId As EditText
	
	Type DBResult (Tag As Object, Columns As Map, Rows As List)
	Type DBCommand (Name As String, Parameters() As Object)
	Private const rdcLink As String = "http://10.0.0.97:17178/rdc"
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	CreateTable
	Log ("Create Table Issued")
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Sub CreateRequest As DBRequestManager
	Dim req As DBRequestManager
	req.Initialize(Me, rdcLink)
	Return req
End Sub

Sub CreateCommand(Name As String, Parameters() As Object) As DBCommand
	Dim cmd As DBCommand
	cmd.Initialize
	cmd.Name = Name
	If Parameters <> Null Then cmd.Parameters = Parameters
	Return cmd
End Sub

Private Sub btSend_Click
	InsertRecord (txSystem.Text, txId.Text, txFromId.Text, txToId.Text, txData.Text)
End Sub

Private Sub btReceive_Click
	GetRecord (txSystem.Text,txId.Text, txToId.Text)
End Sub

Sub CreateTable ()
	Dim cmd As DBCommand = CreateCommand("CreateTable", Null)
	Dim j As HttpJob = CreateRequest.ExecuteBatch(Array(cmd), Null)
	Wait For(j) JobDone(j As HttpJob)
	If j.Success Then
		Log("Table Created successfully!")
	End If
	j.Release
End Sub

Sub InsertRecord (Sys As String, Id As String, FromId As String, ToId As String, sData As String)
	Dim cmd As DBCommand = CreateCommand("AddSync", Array(Sys,Id,FromId,ToId,sData))
	Dim j As HttpJob = CreateRequest.ExecuteBatch(Array(cmd), Null)
	Wait For(j) JobDone(j As HttpJob)
	If j.Success Then
		Log("Inserted successfully!")
	End If
	j.Release
End Sub

Sub GetRecord (Sys As String, Id As String, ToId As String)
	Dim req As DBRequestManager = CreateRequest
	Dim cmd As DBCommand = CreateCommand("ReadSync", Array(Sys,Id,ToId))
	Wait For (req.ExecuteQuery(cmd, 0, Null)) JobDone(j As HttpJob)
	If j.Success Then
		req.HandleJobAsync(j, "req")
		Wait For (req) req_Result(res As DBResult)
		'work with result
		req.PrintTable(res)
	Else
		Log("ERROR: " & j.ErrorMessage)
	End If
	j.Release
End Sub